{ Componente  : WebLabel
  Utilizzo    : WebLabel  una normalissima label con caratteristiche ipertestuali
  E-Mail      : delphiruby@yahoo.it
  Web site    : http://www.compuservonline.com/delphiruby/
  Version     : 1.0
  Note        : WebLabel ha la possibilit di creare un collegamento al sito
                inserito nella caption es: http://www.compuservonline.com/delphiruby/
                oppure : www.compuservonline.com/delphiruby/

  Uso         : caption         : scrivere l'indirizzo web al quale si vuole
                                  effettuare il collegamento.
                enableLink      : Boolean che se si trova a false non abilita
                                  il richiamo della pagina web (default TRUE)
                nuovocolore     : colore che assume l'indirizzo web quando
                                  il mouse ci passa sopra.
  Copyright  2003 DelphiRuby
}
unit WebLabel;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TWebLabel = class(TLabel)
  private
    { Private declarations }
    FAutore : String;
    FVuoto :String;
    fAbilitaLink : Boolean;
    FNuovoColore: TColor;
    FVecchioColore: TColor;
    procedure SetAbilitaLink(const Value: Boolean);
  protected
    { Protected declarations }
    procedure CmMouseEnter(var Message: TMessage); message CM_MOUSEENTER;
    procedure CmMouseLeave(var Message: TMessage); message CM_MOUSELEAVE;
    procedure Click; override;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    { Published declarations }
    property Autore : string  read FAutore write Fvuoto;
    property NuovoColore: TColor read FNuovoColore write FNuovoColore default clYellow;
    property EnableLink: boolean read fAbilitaLink write SetAbilitaLink  default True ;
  end;

procedure Register;

implementation
uses
  ShellAPI;

constructor TWebLabel.Create(AOwner: TComponent);
 begin
  inherited;
  FAutore :='DelphiRuby (Copyright  2003)';
  FNuovoColore := clYellow;
  FVecchioColore := Font.Color;
  fAbilitaLink:= True;
  Cursor := crHandPoint;
  Font.Color := clBlue;
  Font.Style := Font.Style + [fsUnderline];// carattere sottolineato
 end;

procedure TWebLabel.Click;
begin
  inherited;
  if fAbilitaLink then
  ShellExecute(Parent.Handle, 'open', PChar(Caption), '', '', SW_NORMAL);
end;

// Quando sono sul testo cambio il colore BLU con quello scelto
procedure TWebLabel.CmMouseEnter(var Message: TMessage);
begin
  inherited;
  FVecchioColore := Font.Color;
  Font.Color := FNuovoColore;  // il colore del quale diventa il testo quando vado sopra
end;

//Quando non sono pi sulla scritta ripristino il colore Blu
procedure TWebLabel.CmMouseLeave(var Message: TMessage);
begin
  inherited;
  Font.Color := FVecchioColore;
end;

procedure TWebLabel.SetAbilitaLink(const Value: Boolean);
 begin
  fAbilitaLink := Value;
 end;

destructor TWebLabel.Destroy;
begin
  inherited;
end;

procedure Register;
begin
  RegisterComponents('DelphiRuby', [TWebLabel]);
end;

end.
